	# Module for MyDrupalStore
	# Ver 0.0.8
	# 02 Nov 2010 16:25
	package StoreInDrupal;
	use strict;
	use warnings;
	use utf8;
	use open OUT => ':utf8';
	use open ':utf8';
	use open IO => ':utf8';
	use Time::localtime;
	use List::Util;
	use XML::LibXML;
	use XML::LibXML::Common;
	use XML::NamespaceSupport;
	use XML::SAX;
	use MIME::Base64;
	use File::HomeDir;
	use Encode;
	our $VERSION = '0.07';
	our $dbh;
	our $dbname   = "";
	our $hostname = "localhost";
	our $password = "password";
	our $username = "username";
	our $userid   = 0;
	require DBD::mysql;

	sub sql_insert($$) {
		my $hdb    = shift;
		my $sqlstr = shift;
		my $res    = $hdb->prepare($sqlstr)
		  or die("Error in INSERT (string=$sqlstr)");
		my $rownum = $res->execute()
		  or die("Error in INSERT execute (string=\"$sqlstr\")");
		my %resh = ( 'result', $res, 'rownum', $rownum );
		$hdb->do("COMMIT;");
		return %resh;
	}

	sub sql_update($$) {
		my $hdb    = shift;
		my $sqlstr = shift;
		my $res    = $hdb->prepare($sqlstr)
		  or die("Error in UPDATE (string=$sqlstr)");
		my $rownum = $res->execute()
		  or die("Error in UPDATE execute (string=\"$sqlstr\")");
		my %resh = ( 'result', $res, 'rownum', $rownum );
		$hdb->do("COMMIT;");
		return %resh;
	}

	sub sql_select($$) {
		my $hdb    = shift;
		my $sqlstr = shift;
		my $res    = $hdb->prepare($sqlstr)
		  or die("Error in SELECT (string=$sqlstr)");
		my $rownum = $res->execute()
		  or die("Error in SELECT execute (string=\"$sqlstr\")");
		my %resh = ( 'result', $res, 'rownum', $rownum );
		return %resh;
	}

	sub getconfig {
		my $homedir = File::HomeDir->my_home;
		my $parser  = XML::LibXML->new();
		my $doc     =
		  $parser->parse_file(
			"$homedir/.kde/share/apps/amarok/scripts-data/config-script.xml");
		my $config = $doc->getDocumentElement();
		my @nodes  = $config->getElementsByTagName("database");
		$dbname   = $nodes[0]->textContent;
		@nodes    = $config->getElementsByTagName("hostname");
		$hostname = $nodes[0]->textContent;
		@nodes    = $config->getElementsByTagName("username");
		$username = decode_base64( $nodes[0]->textContent );
		@nodes    = $config->getElementsByTagName("password");
		$password = decode_base64( $nodes[0]->textContent );
		@nodes    = $config->getElementsByTagName("userid");
		$userid   = $nodes[0]->textContent;
	}

	sub new {
		my ( $class, %args ) = @_;
		my $self = bless( {}, $class );
		$self->getconfig();
		my $path   = exists $args{path}   ? $args{path}   : "Invalid Path!";
		my $author = exists $args{author} ? $args{author} : "Invalid Author!";
		my $album  = exists $args{album}  ? $args{album}  : "Invalid Album!";
		my $genre  = exists $args{genre}  ? $args{genre}  : "Invalid Genre!";
		$self->path($path);
		$self->author($author);
		$self->album($album);
		$self->genre($genre);
		return $self;
	}

	sub path {
		my $self = shift;
		if (@_) {
			my $path = shift;
			$self->{path} = $path;
		}

		return $self->{path};
	}

	sub author {
		my $self = shift;
		if (@_) {
			my $author = shift;
			$self->{author} = $author;
		}

		return $self->{author};
	}

	sub album {
		my $self = shift;
		if (@_) {
			my $album = shift;
			$self->{album} = $album;
		}

		return $self->{album};
	}

	sub genre {
		my $self = shift;
		if (@_) {
			my $genre = shift;
			$self->{genre} = $genre;
		}

		return $self->{genre};
	}

	sub print {
		my $self = shift;
		my $aaa  = $self->path();
		my $aaa1 = $self->author();
		my $aaa2 = $self->album();
		my $aaa3 = $self->genre();
		print "$aaa,$aaa1,$aaa2,$aaa3 \n";
	}

	sub openconnection {
		$dbh =
		  DBI->connect( "DBI:mysql:$dbname:$hostname", $username, $password,
			{ "AutoCommit" => 1 } )
		  or die("Can't connect DB");
		$dbh->do("set character set utf8");
		$dbh->do("SET NAMES 'utf8';");
		$dbh->{mysql_enable_utf8} = 1;
		return $dbh;
	}

	sub find_last_number {
		my $self = shift;
		my $hdb  = shift;

		# find last node number
		my $sqlstr = "SELECT max(nid) FROM " . $dbname . ".node;";
		my $res    = $hdb->prepare($sqlstr) or die("Error in SELECT");
		my $rownum = $res->execute() or die("Error in SELECT execute");
		my @row    = $res->fetchrow_array();
		return $row[0];
	}

	sub getpath {
		my $self   = shift;
		my $hdb    = shift;
		my %resh   = ();
		my $path   = $hdb->quote( $self->path() );
		my $sqlstr =
		  "SELECT nid FROM $dbname.node WHERE title=$path AND type='path';";
		my $rownum = 0;
		%resh = sql_select( $hdb, $sqlstr );
		if ( $resh{'rownum'} > 0 ) {
			my @r = $resh{'result'}->fetchrow_array();
			return $r[0];
		}
		my $lastno = find_last_number( $self, $hdb ) + 1;

		# 1. add to node
		$sqlstr =
		    "INSERT INTO " . $dbname
		  . ".node (vid,type,language,title,uid,status,created,changed,comment,promote,moderate,sticky,tnid,translate) VALUES ("
		  . $lastno
		  . ",'path','ru',$path,$userid,1,"
		  . time() . ","
		  . time()
		  . ",0,1,0,0,0,0);";
		%resh = sql_insert( $hdb, $sqlstr );
		%resh = sql_select( $hdb, "SELECT LAST_INSERT_ID();" );
		my $res = $resh{'result'};
		my @rr  = $res->fetchrow_array();
		my $ln  = $rr[0];
		$sqlstr = "UPDATE $dbname.node SET vid=$ln WHERE nid=$ln;";
		%resh   = sql_update( $hdb, $sqlstr );
		$lastno = $ln;

		# 2. add to node_revisions
		$sqlstr =
"INSERT INTO $dbname.node_revisions (nid,vid,uid,title,body,teaser,log,timestamp,format) VALUES ($ln,$ln,$userid,$path,$path,'  ','  ',"
		  . time() . ",0);";
		%resh = sql_insert( $hdb, $sqlstr );
		return $lastno;
	}

	sub getauthor {
		my $self   = shift;
		my $hdb    = shift;
		my $author = $hdb->quote( $self->author() );
		my $sqlstr =
		  "SELECT nid FROM $dbname.node WHERE title=$author AND type='author';";
		my $res    = $hdb->prepare($sqlstr) or die("Error in SELECT");
		my $rownum = $res->execute()        or die("Error in SELECT execute");
		if ( $rownum > 0 ) {
			my @r = $res->fetchrow_array();
			return $r[0];
		}
		my $lastno = find_last_number( $self, $hdb ) + 1;

		# 1. add to node
		$sqlstr =
		    "INSERT INTO " . $dbname
		  . ".node (vid,type,language,title,uid,status,created,changed,comment,promote,moderate,sticky,tnid,translate) VALUES ("
		  . $lastno
		  . ",'author','ru',$author,$userid,1,"
		  . time() . ","
		  . time()
		  . ",0,1,0,0,0,0);";
		my %resh = sql_insert( $hdb, $sqlstr );
		$res = $hdb->prepare("SELECT LAST_INSERT_ID();")
		  or die("Error in SELECT");
		$rownum = $res->execute() or die("Error in SELECT execute");
		my @rr = $res->fetchrow_array();
		my $ln = $rr[0];
		$sqlstr = "UPDATE $dbname.node SET vid=$ln WHERE nid=$ln;";
		%resh   = sql_update( $hdb, $sqlstr );
		$lastno = $ln;

		# 2. add to node_revisions
		$sqlstr =
"INSERT INTO $dbname.node_revisions (nid,vid,uid,title,body,teaser,log,timestamp,format) VALUES ($ln,$ln,$userid,$author,$author,'  ','  ',"
		  . time() . ",0);";
		%resh = sql_insert( $hdb, $sqlstr );
		return $lastno;
	}

	sub getalbum {
		my $self   = shift;
		my $hdb    = shift;
		my $album  = $hdb->quote( $self->album() );
		my $sqlstr =
		  "SELECT nid FROM $dbname.node WHERE title=$album AND type='album';";
		my $res    = $hdb->prepare($sqlstr) or die("Error in SELECT");
		my $rownum = $res->execute()        or die("Error in SELECT execute");
		if ( $rownum > 0 ) {
			my @r = $res->fetchrow_array();
			return $r[0];
		}
		my $lastno = find_last_number( $self, $hdb ) + 1;

		# 1. add to node
		$sqlstr =
		    "INSERT INTO " . $dbname
		  . ".node (vid,type,language,title,uid,status,created,changed,comment,promote,moderate,sticky,tnid,translate) VALUES ("
		  . $lastno
		  . ",'album','ru',$album,$userid,1,"
		  . time() . ","
		  . time()
		  . ",0,1,0,0,0,0);";
		my %resh = sql_insert( $hdb, $sqlstr );
		$res = $hdb->prepare("SELECT LAST_INSERT_ID();")
		  or die("Error in SELECT");
		$rownum = $res->execute() or die("Error in SELECT execute");
		my @rr = $res->fetchrow_array();
		my $ln = $rr[0];
		$sqlstr = "UPDATE $dbname.node SET vid=$ln WHERE nid=$ln;";
		%resh   = sql_update( $hdb, $sqlstr );
		$lastno = $ln;

		# 2. add to node_revisions
		$sqlstr =
"INSERT INTO $dbname.node_revisions (nid,vid,uid,title,body,teaser,log,timestamp,format) VALUES ($ln,$ln,$userid,$album,$album,'  ','  ',"
		  . time() . ",0);";
		%resh = sql_insert( $hdb, $sqlstr );
		return $lastno;
	}

	sub getgenre {
		my $self   = shift;
		my $hdb    = shift;
		my $genre  = $hdb->quote( $self->genre() );
		my $sqlstr =
		  "SELECT nid FROM $dbname.node WHERE title=$genre AND type='genre';";
		my $res    = $hdb->prepare($sqlstr) or die("Error in SELECT");
		my $rownum = $res->execute()        or die("Error in SELECT execute");
		if ( $rownum > 0 ) {
			my @r = $res->fetchrow_array();
			return $r[0];
		}
		my $lastno = find_last_number( $self, $hdb ) + 1;

		# 1. add to node
		$sqlstr =
		    "INSERT INTO " . $dbname
		  . ".node (vid,type,language,title,uid,status,created,changed,comment,promote,moderate,sticky,tnid,translate) VALUES ("
		  . $lastno
		  . ",'genre','ru',$genre,$userid,1,"
		  . time() . ","
		  . time()
		  . ",0,1,0,0,0,0);";
		my %resh = sql_insert( $hdb, $sqlstr );
		$res = $hdb->prepare("SELECT LAST_INSERT_ID();")
		  or die("Error in SELECT");
		$rownum = $res->execute() or die("Error in SELECT execute");
		my @rr = $res->fetchrow_array();
		my $ln = $rr[0];
		$sqlstr = "UPDATE $dbname.node SET vid=$ln WHERE nid=$ln;";
		%resh   = sql_update( $hdb, $sqlstr );
		$lastno = $ln;

		# 2. add to node_revisions
		$sqlstr =
"INSERT INTO $dbname.node_revisions (nid,vid,uid,title,body,teaser,log,timestamp,format) VALUES ($ln,$ln,$userid,$genre,$genre,'  ','  ',"
		  . time() . ",0);";
		%resh = sql_insert( $hdb, $sqlstr );
		return $lastno;
	}

	sub sendtrack($%$) {
		my $self     = shift;
		my $hdb      = shift;
		my $track    = shift;
		my $flag     = shift;
		my $rownum   = 0;
		my %resh     = ();
		my @r        = ();
		my $fullname = $hdb->quote( $track->{'fullname'} );
		my $URL      = $hdb->quote( $track->{'URL'} );
		my $pathid   = $track->{'pathid'};
		my $authorid = $track->{'authorid'};
		my $albumid  = $track->{'albumid'};
		my $title    = $hdb->quote( $track->{'name'} );
		my $titlep   = $hdb->quote( '%' . $track->{'name'} . '%' );
		my $trackno  = $track->{'trackno'};
		my $lp       = $track->{'lastplayed'};
		my $year     = $track->{'year'};
		my $genreid  = $track->{'genreid'};
		my $ttime    = $track->{'totaltime'};
		my $bitrate  = $track->{'bitrate'};
		my $cnt      = $track->{'count'};
		my $rate     = $track->{'rate'};
		my $size     = $track->{'size'};
		my $rating   = $track->{'rating'} * 10;
		if ( ( $bitrate == 0 ) || ( $size == 0 ) ) {
			return "Wrong arguments $bitrate or $size";
		}
		my $result = "";
		my $nid    = 0;
		my %cntm   = ();
		if ( $trackno eq '' ) { $trackno = -1; }
		my $lpint  = time();
		my $res    = 0;
		my $mz     = 0;
		my $sqlstr =
"SELECT nid,field_count_value FROM $dbname.content_type_track WHERE field_path_nid=$pathid AND field_author_nid=$authorid AND field_album_nid=$albumid and field_trackno_value=$trackno;";
		%resh   = sql_select( $hdb, $sqlstr );
		$res    = $resh{'rownum'};
		$result = "[$sqlstr] (return $res rows) ";

		if ( $res > 0 ) {    # Уже есть такая строка
			if ( $res == 1 ) {    # и она одна
				@r      = $resh{'result'}->fetchrow_array();
				$nid    = $r[0];
				$cnt    = $r[1];
				$mz     = 0;
				$sqlstr =
"SELECT title,nid,changed FROM $dbname.node WHERE nid=$nid AND title LIKE $titlep;";
			}
			else # Есть несколько строк с такими параметрами
			{
				$res = "(1";
				while ( @r = $resh{'result'}->fetchrow_array() ) {
					$cntm{ $r[0] } = $r[1];
					$nid           = $r[0];
					$res           = "$res,$nid";
				}
				$mz     = 1;
				$res    = "$res)";
				$sqlstr =
"SELECT title,nid,changed FROM $dbname.node WHERE nid in $res AND title LIKE $titlep;";
			}

			%resh   = sql_select( $hdb, $sqlstr );
			$res    = $resh{'rownum'};
			$result = "$result \n[$sqlstr] (return $res rows) ";
			if ( $res > 0 ) {
				@r = $resh{'result'}->fetchrow_array();
				my $zz = $hdb->quote( $r[0] );
				if ($mz) { $cnt = $cntm{ $r[1] }; $nid = $r[1]; }
				my $oldchnged = $r[2];
				if ( $oldchnged > time() - $ttime / 2 ) {
					my $rtim = time() - $oldchnged - $ttime / 2;
					return "Time too low : $result\n ($rtim) ";
				}
				$sqlstr =
				  "UPDATE $dbname.node SET changed=$lpint WHERE nid=$nid;";
				%resh = sql_update( $hdb, $sqlstr );
				if ($flag) {
					$cnt += 1;
					%resh = sql_select( $hdb,
"SELECT MAX(vid) FROM $dbname.content_type_track_history"
					);
					if ( $resh{'rownum'} > 0 ) {
						@r = $resh{'result'}->fetchrow_array();
						my $nvid = $r[0] + 1;
						$sqlstr =
"INSERT INTO $dbname.content_type_track_history (nid,vid,field_track_nid,field_date_001_value) VALUES ($nvid,$nvid,$nid,$lpint);";
						%resh = sql_insert( $hdb, $sqlstr );
					}
					else {
						$sqlstr =
"INSERT INTO $dbname.content_type_track_history (nid,vid,field_track_nid,field_date_001_value) VALUES (1,1,$nid,$lpint);";
						%resh = sql_insert( $hdb, $sqlstr );
						$result = "$result\nEmpty content_type_track_history";
					}
				}

				# Обновим статистику и рейтинг
				$sqlstr =
"SELECT field_rating_rating,field_rate_value FROM $dbname.content_type_track WHERE nid=$nid;";
				%resh = sql_select( $hdb, $sqlstr );
				if ( $resh{'rownum'} > 0 ) {
					@r = $resh{'result'}->fetchrow_array();
					my $sqlrate   = $r[0];
					my $sqlrating = $r[1];
					$rating = List::Util::max( $rating, $sqlrating );
					if ( $sqlrate > 0 ) {
						if ( $rate > 0 ) {
							$rate = ( $sqlrate + $rate ) / 2;
						}
						else {
							$rate = $sqlrate;
						}
					}
					else {
						if ( $rate > 0 ) {
							$rate = ( $rate + 100 ) / 2;
						}
						else {
							$rate = 55;
						}
					}
				}
				else { return -11; }
				$sqlstr =
"UPDATE $dbname.content_type_track SET field_count_value=$cnt,field_lastplay_value=$lpint,field_rate_value=$rate,field_rating_rating=$rating WHERE nid=$nid;";
				%resh = sql_update( $hdb, $sqlstr );
				$sqlstr =
				  "SELECT log,nid FROM $dbname.node_revisions WHERE nid=$nid;";
				$res = $hdb->prepare($sqlstr) or die("Error in SELECT");
				$rownum = $res->execute() or die("Error in SELECT execute");
				if ( $rownum > 0 ) {
					@r = $res->fetchrow_array();
					my $log = $hdb->quote( $r[0] . "\n" . $lp );
					$sqlstr =
"UPDATE $dbname.node_revisions SET log=$log WHERE nid=$nid";
					%resh = sql_update( $hdb, $sqlstr );
				}
				return "Normal update : \n$result";
			}

		}

		my $lastno = find_last_number( $self, $hdb ) + 1;

		# 1. add to node
		$sqlstr =
		    "INSERT INTO " . $dbname
		  . ".node (vid,type,language,title,uid,status,created,changed,comment,promote,moderate,sticky,tnid,translate) VALUES ("
		  . $lastno
		  . ",'track','ru',$title,$userid,1,"
		  . time() . ","
		  . time()
		  . ",0,1,0,0,0,0);";
		%resh = sql_insert( $hdb, $sqlstr );
		$res = $hdb->prepare("SELECT LAST_INSERT_ID();")
		  or die("Error in SELECT");
		$rownum = $res->execute() or die("Error in SELECT execute");
		my @rr = $res->fetchrow_array();
		my $ln = $rr[0];
		$sqlstr = "UPDATE $dbname.node SET vid=$ln WHERE nid=$ln;";
		%resh   = sql_update( $hdb, $sqlstr );
		$lastno = $ln;

		# 2. add to node_revisions
		$sqlstr =
"INSERT INTO $dbname.node_revisions (nid,vid,uid,title,body,teaser,log,timestamp,format) VALUES ($ln,$ln,$userid,$title,$fullname,$URL,'$lp\n',"
		  . time() . ",0);";
		%resh = sql_insert( $hdb, $sqlstr );

		# 3. add track node
		if ($flag) {
			$cnt += 1;
			$sqlstr = "SELECT MAX(vid) FROM $dbname.content_type_track_history";
			$res = $hdb->prepare($sqlstr) or die("Error in SELECT ($sqlstr)");
			$rownum = $res->execute()
			  or die("Error in SELECT execute ($sqlstr)");
			if ( $rownum > 0 ) {
				my @r    = $res->fetchrow_array();
				my $nvid = $r[0] + 1;
				$sqlstr =
"INSERT INTO $dbname.content_type_track_history (nid,vid,field_track_nid,field_date_001_value) VALUES ($nvid,$nvid,$ln,$lpint);";
				my %resh = sql_insert( $hdb, $sqlstr );
			}
			else { return -2; }
		}
		$sqlstr =
"INSERT INTO $dbname.content_type_track (nid,vid,field_album_nid,field_year_value,field_author_nid,field_genre_nid,field_path_nid,field_trackno_value,field_time_value,field_bitrate_value,field_count_value,field_filesize_value,field_lastplay_value,field_rate_value,field_rating_rating,field_rating_target) "
		  . "VALUES ($ln,$ln,$albumid,$year,$authorid,$genreid,$pathid,$trackno,$ttime,$bitrate,$cnt,$size,$lpint,$rate,$rating,1);";
		%resh = sql_insert( $hdb, $sqlstr );
		return
"Result : Full add node $lastno\n$result\n[$title],[$trackno],[$albumid],[$authorid],[$pathid],[$genreid]\n";
	}

