#!/usr/bin/perl
# Main module
# Ver 0.0.5
# 02 Nov 2010 16:25
use strict;
use open OUT => ':utf8';
use open ':utf8';
use open IO => ':utf8';
use File::HomeDir;
use lib '/home/tolmi/.kde/share/apps/amarok/scripts-data';
use Encode;
use utf8;
use File::Basename;
use StoreInDrupal;
use Encode;
our $pind = "";
our $dbh  = "";

sub savetrack($) {
	my $flag   = shift;
	my %track  = ();
	my $btmp   = 0;
	my $ffname = dcopsys("player path");
	if ( length($ffname) == 0 ) { return "Null File"; }
	my $filename = basename $ffname;
	my $dirname  = dirname $ffname;
	$track{'URL'}      = dcopsys("player encodedURL");
	$track{'filename'} = $filename;
	$track{'name'}     = dcopsys("player title");
	$track{'fullname'} = $ffname;
	$track{'year'}     = dcopsys("player year");
	$track{'trackno'}  = dcopsys("player track");
	$btmp              = dcopsys("player bitrate");
	if ( $btmp > 0 ) { $track{'bitrate'} = $btmp; }
	else { return "Wrong bitrate"; }
	$track{'rate'}       = dcopsys("player score");
	$track{'count'}      = dcopsys("player trackPlayCounter");
	$track{'totaltime'}  = dcopsys("player trackTotalTime");
	$track{'rating'}     = dcopsys("player rating");
	$track{'count'}      = dcopsys("player trackPlayCounter");
	$track{'size'}       = -s $ffname;
	$track{'lastplayed'} = localtime();
	$pind->path($dirname);
	$pind->album( dcopsys("player album") );
	$pind->author( dcopsys("player artist") );
	$pind->genre( dcopsys("player genre") );
	my $pathid   = $pind->getpath($dbh);
	my $albumid  = $pind->getalbum($dbh);
	my $authorid = $pind->getauthor($dbh);
	my $genreid  = $pind->getgenre($dbh);
	$track{'pathid'}   = $pathid;
	$track{'albumid'}  = $albumid;
	$track{'authorid'} = $authorid;
	$track{'genreid'}  = $genreid;
	$pind->sendtrack( $dbh, \%track, $flag );
}

sub dcopsys($) {
	my $commd = shift;
	open DATA, "dcop amarok $commd|" or die("DCOP error");
	binmode DATA, ":utf8";
	my $theDate = <DATA>;
	close(DATA);
	chomp($theDate);
	return $theDate;
}
my $line    = "";
my $msg     = "";
my $r       = 0;
my $homedir = File::HomeDir->my_home;
open( FLOG, ">$homedir/script-log.txt" ) or die("Log File error");
binmode FLOG,  ":utf8";
binmode STDIN, ":utf8";
$pind = StoreInDrupal->new();
$dbh  = $pind->openconnection();

while (<STDIN>) {
	chomp();
	$line = $_;
	my $title = dcopsys("player title");
	if ( $title eq "" ) { next; }
	my $lt = localtime();
	print FLOG "$lt EVENT \"$line\" - $title \n";
	if ( $line =~ /configure/i ) {
		$msg = 'This script does not require any configuration.';
		$msg = "\"$msg\"";
		dcopsys(" playlist popupMessage $msg");
	}
	if ( $line =~ /requestnewscore/i ) {
		$r = savetrack(0);
		print FLOG "$lt savetrack(0) return ($r) [$title] \n";
	}
	elsif ( $line =~ /enginestatechange.*playing/i ) {
		$r = savetrack(1);
		print FLOG "$lt savetrack(1) return ($r) [$title] \n";
	}
	elsif ( $line =~ /playlistchange.*change/i ) {
		$r = savetrack(1);
		print FLOG "$lt savetrack(0) return ($r) [$title] \n";
	}
	elsif ( $line =~ /playlistchange.*paused/i ) {
		$r = savetrack(0);
		print FLOG "$lt savetrack(0) return ($r) [$title] \n";
	}
	elsif ( $line =~ /trackChange/i ) {
		$r = savetrack(1);
		print FLOG "$lt savetrack(1) return ($r) [$title] \n";
	}
	elsif ( $line =~ /enginestatechange.*paused/i ) {
		print FLOG "$lt Playing paused\n";
	}
	else {
		$msg = encode( "latin1", "$line" );
		print FLOG "$lt unknown command 1 \"$line\" \n";
	}
}
1;
